#include <stdint.h>

#include "fe.h"

void fe_invert(int32_t out[10], int32_t z[10]) {
	int32_t t0[10];
	int32_t t1[10];
	int32_t t2[10];
	int32_t t3[10];
	int i;

	/* qhasm: z2 = z1^2^1 */
	fe_sq(t0,z); for (i = 1;i < 1;++i) fe_sq(t0,t0);

	/* qhasm: z8 = z2^2^2 */
	fe_sq(t1,t0); for (i = 1;i < 2;++i) fe_sq(t1,t1);

	/* qhasm: z9 = z1*z8 */
	fe_mul(t1,z,t1);

	/* qhasm: z11 = z2*z9 */
	fe_mul(t0,t0,t1);

	/* qhasm: z22 = z11^2^1 */
	fe_sq(t2,t0); for (i = 1;i < 1;++i) fe_sq(t2,t2);

	/* qhasm: z_5_0 = z9*z22 */
	fe_mul(t1,t1,t2);

	/* qhasm: z_10_5 = z_5_0^2^5 */
	fe_sq(t2,t1); for (i = 1;i < 5;++i) fe_sq(t2,t2);

	/* qhasm: z_10_0 = z_10_5*z_5_0 */
	fe_mul(t1,t2,t1);

	/* qhasm: z_20_10 = z_10_0^2^10 */
	fe_sq(t2,t1); for (i = 1;i < 10;++i) fe_sq(t2,t2);

	/* qhasm: z_20_0 = z_20_10*z_10_0 */
	fe_mul(t2,t2,t1);

	/* qhasm: z_40_20 = z_20_0^2^20 */
	fe_sq(t3,t2); for (i = 1;i < 20;++i) fe_sq(t3,t3);

	/* qhasm: z_40_0 = z_40_20*z_20_0 */
	fe_mul(t2,t3,t2);

	/* qhasm: z_50_10 = z_40_0^2^10 */
	fe_sq(t2,t2); for (i = 1;i < 10;++i) fe_sq(t2,t2);

	/* qhasm: z_50_0 = z_50_10*z_10_0 */
	fe_mul(t1,t2,t1);

	/* qhasm: z_100_50 = z_50_0^2^50 */
	fe_sq(t2,t1); for (i = 1;i < 50;++i) fe_sq(t2,t2);

	/* qhasm: z_100_0 = z_100_50*z_50_0 */
	fe_mul(t2,t2,t1);

	/* qhasm: z_200_100 = z_100_0^2^100 */
	fe_sq(t3,t2); for (i = 1;i < 100;++i) fe_sq(t3,t3);

	/* qhasm: z_200_0 = z_200_100*z_100_0 */
	fe_mul(t2,t3,t2);

	/* qhasm: z_250_50 = z_200_0^2^50 */
	fe_sq(t2,t2); for (i = 1;i < 50;++i) fe_sq(t2,t2);

	/* qhasm: z_250_0 = z_250_50*z_50_0 */
	fe_mul(t1,t2,t1);

	/* qhasm: z_255_5 = z_250_0^2^5 */
	fe_sq(t1,t1); for (i = 1;i < 5;++i) fe_sq(t1,t1);

	/* qhasm: z_255_21 = z_255_5*z11 */
	fe_mul(out,t1,t0);

	return;
}
