#include <stdint.h>

/*
h = f - g
Can overlap h with f or g.

Preconditions:
   |f| bounded by 1.1*2^25,1.1*2^24,1.1*2^25,1.1*2^24,etc.
   |g| bounded by 1.1*2^25,1.1*2^24,1.1*2^25,1.1*2^24,etc.

Postconditions:
   |h| bounded by 1.1*2^26,1.1*2^25,1.1*2^26,1.1*2^25,etc.
*/

void fe_sub(int32_t h[10], int32_t f[10], int32_t g[10]) {
	int32_t f0 = f[0];
	int32_t f1 = f[1];
	int32_t f2 = f[2];
	int32_t f3 = f[3];
	int32_t f4 = f[4];
	int32_t f5 = f[5];
	int32_t f6 = f[6];
	int32_t f7 = f[7];
	int32_t f8 = f[8];
	int32_t f9 = f[9];
	int32_t g0 = g[0];
	int32_t g1 = g[1];
	int32_t g2 = g[2];
	int32_t g3 = g[3];
	int32_t g4 = g[4];
	int32_t g5 = g[5];
	int32_t g6 = g[6];
	int32_t g7 = g[7];
	int32_t g8 = g[8];
	int32_t g9 = g[9];
	int32_t h0 = f0 - g0;
	int32_t h1 = f1 - g1;
	int32_t h2 = f2 - g2;
	int32_t h3 = f3 - g3;
	int32_t h4 = f4 - g4;
	int32_t h5 = f5 - g5;
	int32_t h6 = f6 - g6;
	int32_t h7 = f7 - g7;
	int32_t h8 = f8 - g8;
	int32_t h9 = f9 - g9;
	h[0] = h0;
	h[1] = h1;
	h[2] = h2;
	h[3] = h3;
	h[4] = h4;
	h[5] = h5;
	h[6] = h6;
	h[7] = h7;
	h[8] = h8;
	h[9] = h9;
}
