#!/bin/sh

# test addfile

#printf "# PATH=%s\n" "$PATH" 1>&2
. tap.sh

PF=test.db

plan 34

require rm -rf tmp
require mkdir tmp
cd tmp || bailout 'cannot cd to tmp'

echo foo > foo
okexit 'making foo'

pkgid=zpmtest-1.0-1
PF=zpmtest-1.0-1.zpm

require -v zpm newpackage -C $pkgid
require -v zpm add -vvv -f $PF -p $pkgid foo
h=$(zpm hash foo)
diag "hash $h"
require -v zpm extract -f zpmtest-1.0-1.zpm $h foo2
h2=$(zpm hash foo2)
okstreq "$h" "$h2" "foo and foo2 hash match"

pkglist=$(zpm showpkg zpmtest-1.0-1.zpm)
set $pkglist
okstreq "$1" "zpmtest" package name
okstreq "$2" "1.0" package version
okstreq "$3" "1" package release
okstreq "$4" "/foo" file foo in package
diag "$pkglist"

rm -f $PF
require zpm newpackage -f $PF -C $pkgid
require zpm add -f $PF -p zpmtest foo
rm -f foo2
require zpm extract -f $PF $h foo2
h2=$(zpm hash foo2)
okstreq "$h" "$h2"

pkglist=$(zpm showpkg $PF)
set $pkglist
okstreq "$1" "zpmtest" package name
okstreq "$2" "1.0" package version
okstreq "$3" "1" package release
okstreq "$4" "/foo" file foo in package
diag "$pkglist"

rm -f $PF
mkdir subdir
touch subdir/foo
require zpm newpackage -f $PF -C $pkgid
require -v zpm add -f $PF -S subdir -p zpmtest subdir/foo
fn=$(zpm showpkg $PF | awk '{print $4}')
okstreq "$fn" "/foo" file foo in package prefix striped
rm -f $PF

require zpm newpackage -f $PF -C $pkgid
require zpm add -f $PF -p zpmtest foo
ph=$(zpm pkg -f $PF zpmtest hash)
okstreq "$ph" "" package hash empty
mtime=$(zpm pkg -f $PF zpmtest build_time)
okstreq "$ph" "" package mtime empty

zpm add -C -f $PF -p zpmtest subdir/foo
okexit added file and completed package
ph=$(zpm pkg -f $PF zpmtest hash)
test -n "$ph"
okexit package hash not empty
diag "hash: $ph"
mtime=$(zpm pkg -f $PF zpmtest build_time)
test -n "$mtime"
okexit package mtime not empty

touch subdir/bar
require zpm add -f $PF -p zpmtest subdir/bar
ph=$(zpm pkg -f $PF zpmtest hash)
okstreq "$ph" "" package hash cleared
mtime=$(zpm pkg -f $PF zpmtest build_time)
okstreq "$ph" "" package mtime cleared

echo junk data > subdir/baz
require zpm add -f $PF subdir/baz
rm $PF
require zpm add -i -f $PF subdir/baz

finish

cd ..
rm -rf tmp
