#!/bin/sh

. tap.sh

plan 20

PF=test.db

require rm -rf tmp
require mkdir tmp
cd tmp || bailout "can not cd to tmp"
require rm -f $PF test.empty
require touch test.empty

zpm test test.empty 2>/dev/null
failsok zpm-test of empty file

zpm init $PF
okexit zpm-init new file

tryrun zpm newpackage -f $PF basics-1.0-1
pkgid=$(zpm list -f $PF)
okstreq "$pkgid" "basics-1.0-1" "have basics 1.0"

require zpm pkg -f $PF basics version=2.0
pkgid=$(zpm list -f $PF)
okstreq "$pkgid" "basics-2.0-1" "have basics 2.0"

tryrun zpm newpackage -f $PF -p foo -l bar -d baz -u quux valset-1.0-1 
val=$(zpm pkg -f $PF valset packager)
okstreq "$val" 'foo' newpackage set packager
val=$(zpm pkg -f $PF valset licenses)
okstreq "$val" 'bar' newpackage set licenses
val=$(zpm pkg -f $PF valset description)
okstreq "$val" 'baz' newpackage set description
val=$(zpm pkg -f $PF valset url)
okstreq "$val" 'quux' newpackage set url

# package dependencies
deps=$(zpm pkgdeps -f $PF valset)
okstreq "$deps" '' new package empty deps
deps=$(zpm pkgdeps -f $PF -s foo valset)
okstreq "$deps" 'foo' pkgdeps set and print
deps=$(zpm pkgdeps -f $PF -c valset)
okstreq "$deps" '' pkgdeps clear
deps=$(zpm pkgdeps -f $PF -q -s foo valset)
okstreq "$deps" '' pkgdeps set and quiet
deps=$(zpm pkgdeps -f $PF valset)
okstreq "$deps" 'foo' pkgdeps set

cd ..
rm -rf tmp
finish

